# ----------------------------------------------------------------------
#  EXAMPLE: Rappture <choice> elements
# ======================================================================
#  AUTHOR:  Michael McLennan, Purdue University
#  Copyright (c) 2004-2005  Purdue Research Foundation
#
#  See the file "license.terms" for information on usage and
#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
# ======================================================================
package require Rappture

# open the XML file containing the run parameters
set driver [Rappture::library [lindex $argv 0]]

set choice [$driver get input.(pick).current]

set f [open "mesh.vtk" "r"]
set data [read $f]
close $f
switch -- $choice {
    "c3" {
	set scalars "c3 C3 eV"
	append data "POINT_DATA 81\n"
	append data "FIELD myFieldData 1\n"
	append data "c3 1 81 float\n"
	set f [open "c3.vtk" "r"]
	append data [read $f]
	close $f
    }
    "c4" {
	set scalars "c4 C4 eV"
	append data "POINT_DATA 81\n"
	append data "FIELD myFieldData 1\n"
	append data "c4 1 81 float\n"
	set f [open "c4.vtk" "r"]
	append data [read $f]
	close $f
    }
    "c5" {
	set scalars "c5 C5 eV"
	append data "POINT_DATA 81\n"
	append data "FIELD myFieldData 1\n"
	append data "c5 1 81 float\n"
	set f [open "c5.vtk" "r"]
	append data [read $f]
	close $f
    }
    "c6" {
	set scalars "c6 C6 eV"
	append data "POINT_DATA 81\n"
	append data "FIELD myFieldData 1\n"
	append data "c6 1 81 float\n"
	set f [open "c6.vtk" "r"]
	append data [read $f]
	close $f
    }
    "all" {
	append data "POINT_DATA 81\n"
	append data "FIELD myFieldData 4\n"
	foreach dataset { c3 c4 c5 c6 } {
	    lappend scalars $dataset [string totitle $dataset] eV
	    append data "$dataset 1 81 float\n"
	    set f [open "$dataset.vtk" "r"]
	    append data [read $f]
	    close $f
	}
    }
}

$driver put output.field.about.view	contour
$driver put output.field.about.scalars	$scalars
$driver put output.field.about.label	"Contour plot"
$driver put output.field.component.vtk  $data
$driver put output.choice(outs).about.label "Echo of choice"
$driver put output.choice(outs).current $choice

# save the updated XML describing the run...
Rappture::result $driver
exit 0
